# Kraken Framework - Console Component

[![Build Status](https://travis-ci.org/kraken-php/framework.svg)](https://travis-ci.org/kraken-php/framework)
[![Total Downloads](https://poser.pugx.org/kraken-php/console/downloads)](https://packagist.org/packages/kraken-php/console) 
[![Latest Stable Version](https://poser.pugx.org/kraken-php/console/v/stable)](https://packagist.org/packages/kraken-php/console) 
[![Latest Unstable Version](https://poser.pugx.org/kraken-php/console/v/unstable)](https://packagist.org/packages/kraken-php/console) 
[![License](https://poser.pugx.org/kraken-php/framework/license)](https://packagist.org/packages/kraken-php/framework)

> **Note:** This repository is part of [Kraken Framework][3]. It can be used as standalone library, but for the best 
efficiency we suggest you to also check out the rest of [Kraken Repository][5].

<br>
<p align="center">
<img src="https://avatars2.githubusercontent.com/u/15938282?v=3&s=150" />
</p>

## Description

Kraken/Console implements both console client and console server to use in applications developed with use of Kraken 
Framework.

## Feature Highlights

Kraken/Console features:

* Remote console-based access to application interface,
* Multiple commands for managing application architecture without need to change code,
* Support for creating own and extending existing commands,
* Transparent and centralized management for distributed application,
* Kraken Framework compatibility,
* ...and more.

## Interface

See more in [official documentation][2].

## Requirements

* PHP-5.5, PHP-5.6 or PHP-7.0+,
* UNIX or ~~Windows~~ OS.

## Installation

```
composer require kraken-php/console
```

## Tests

Tests are provided in [Framework Repository][3].

## Documentation

Documentation for this module can be found in the [official documentation][2].

## Contributing

This library is read-only subtree split of Kraken Framework. To make contributions, please go to [Framework Repository][3].

## License

This library licensed under the same license as [Kraken Framework][3].

[1]: http://kraken-php.com
[2]: http://kraken-php.com/docs/0.3/console
[3]: https://github.com/kraken-php/framework
[4]: https://github.com/kraken-php/kraken
[5]: https://github.com/kraken-php
