# Kraken Framework - Throwable Component

[![Build Status](https://travis-ci.org/kraken-php/framework.svg)](https://travis-ci.org/kraken-php/framework)
[![Total Downloads](https://poser.pugx.org/kraken-php/throwable/downloads)](https://packagist.org/packages/kraken-php/throwable) 
[![Latest Stable Version](https://poser.pugx.org/kraken-php/throwable/v/stable)](https://packagist.org/packages/kraken-php/throwable) 
[![Latest Unstable Version](https://poser.pugx.org/kraken-php/throwable/v/unstable)](https://packagist.org/packages/kraken-php/throwable) 
[![License](https://poser.pugx.org/kraken-php/framework/license)](https://packagist.org/packages/kraken-php/framework)

> **Note:** This repository is part of [Kraken Framework][3]. It can be used as standalone library, but for the best 
efficiency we suggest you to also check out the rest of [Kraken Repository][5].

<br>
<p align="center">
<img src="https://avatars2.githubusercontent.com/u/15938282?v=3&s=150" />
</p>

## Description

Kraken/Throwable is component that provides throwable hierarchy used in Kraken Framework and additional helpers.

## Feature Highlights

Kraken/Throwable features:

* Custom hierarchy of Throwables created in mind of unifying error and exception handling in PHP5 and PHP7,
* Custom format for stack trace,
* Support for chaining Throwables,
* Built-in ErrorHandler,
* Built-in ExceptionHandler,
* Implementation of throwable objects proxy,
* Kraken Framework compatibility,
* ...and more.

## Interface

See more in [official documentation][2].

## Requirements

* PHP-5.5, PHP-5.6 or PHP-7.0+,
* UNIX or ~~Windows~~ OS.

## Installation

```
composer require kraken-php/throwable
```

## Tests

Tests are provided in [Framework Repository][3].

## Documentation

Documentation for this module can be found in the [official documentation][2].

## Contributing

This library is read-only subtree split of Kraken Framework. To make contributions, please go to [Framework Repository][3].

## License

This library licensed under the same license as [Kraken Framework][3].

[1]: http://kraken-php.com
[2]: http://kraken-php.com/docs/0.3/throwable
[3]: https://github.com/kraken-php/framework
[4]: https://github.com/kraken-php/kraken
[5]: https://github.com/kraken-php
